GoldLoot = LibStub("AceAddon-3.0"):NewAddon("GoldLoot", "AceConsole-3.0", "AceEvent-3.0");
local GoldLoot = GoldLoot;

local AceConfig = LibStub("AceConfig-3.0");
local AceConfigDialog = LibStub("AceConfigDialog-3.0")
local AceDB = LibStub("AceDB-3.0")
local AceDBOptions = LibStub("AceDBOptions-3.0")

function GoldLoot:OnInitialize()
		
	self.defaults = {
		profile = {
			rarity = 2,
			vendorPrice = 0,
			config = {
				["junk"] = {check = false},
				["quest"] = {check = true},
				["repair"] = {check = true},
				["release"] = {check = true},
				["bop"] = {check = true},
				[1] = {check = false},
				[2] = {check = false},
				[3] = {check = false},
				[4] = {check = false},
				[5] = {check = false},
				[6] = {check = false},
				[7] = {check = false}
			},
			items = {},
		}
	}
	
	self.db = AceDB:New("GoldLootDB", self.defaults)
	
	self.PVPAreas = {
		["wintergrasp"] = true,
		["tol barad"] = true,
		["tol barad peninsula"] = true
	};
	
	self.rarity = {
		color = {
			[0]="9d9d9d",
			[1]="ffffff",
			[2]="1eff00",
			[3]="0070dd",
			[4]="a335ee",
			[5]="ff8000",
			[6]="e5cc80",
			[7]="e5cc80"
		},
		name = {
			[0] = "|cff9d9d9dPoor|r",
			[1] = "|cffffffffCommon|r",
			[2] = "|cff1eff00Uncommon|r",
			[3] = "|cff0070ddRare|r",
			[4] = "|cffa335eeEpic|r",
			[5] = "|cffff8000Legendary|r",
			--[6] = "|cffe5cc80Artifact|r",
			--[7] = "|cffe5cc80Heirloom|r"
		}
	};

	self.StaticData = {
		["junk"] = { --[1]
			text = "Autoloot/Sell Junk",
			desc = "Autoloot Junk to later sell when you visit a vendor.",
		},		
		["quest"] = { --[8]
			text = "Autoloot Quest items",
			desc = "Autoloot item required to complete your active quests.",
		},
		["bop"] = { --[9]
			text = "Autoloot BoP items",
			desc = "Hides the loot confirmation for Bind on Pickup items and loots them.",
		},
		["repair"] = { --[10]
			text = "Autorepair",
			desc = "Repair your equipment whenever you visit a vendor.",
		},
		["release"] = { --[12]
			text = "Autorelease in PVP Areas",
			desc = "Releases Spirit autometicaly in battlegrounds and world areas with spirit healers.",
		},
		[1] = { --[2]
			text = "Cloth",
			desc = "Autoloot Cloth (eg. Frostweave Cloth, Runecloth, etc)",
			loot = "Cloth"
		},
		[2] = { --[3]
			text = "Minerals",
			desc = "Autoloot Raw mineral ores.",
			loot = "Metal & Stone"
		},
		[3] = { --[4]
			text = "Enchanting Materials",
			desc = "Autoloot Enchanting Materials",
			loot = "Enchanting"
		},
		[4] = { --[5]
			text = "Elemental items",
			desc = "Autoloot Elemental items (eg. Mote of Air, Crystalyzed Fire, Volatile Life, etc)",
			loot = "Elemental"
		},
		[5] = { --[6]
			text = "Leather",
			desc = "Autoloots Leather",
			loot = "Leather"
		},
		[6] = { --[7]
			text = "Herbs",
			desc = "Autoloots Herbs",
			loot = "Herb"
		},
		[7] = {
			text = "Lockboxes",
			desc = "Autoloots Lockboxes"
		}
	};
	
	self.opts = {
		type = "group",
		args = {
			general = {
				order = 1,
				type = "group",
				name = "GoldLoot Settings",
				cmdInline = true,
				args = {
					titleGeneral = {
						order = 1,
						type = "header",
						name = "General Settings",
					},
					["junk"] = {
						order = 2,
						name = self.StaticData["junk"].text,
						desc = self.StaticData["junk"].desc,
						type = "toggle",
						set = function(info, value) GoldLoot.db.profile.config["junk"].check = value; end,
						get = function(info) return GoldLoot.db.profile.config["junk"].check end,
					},
					["quest"] = {
						order = 3,
						name = self.StaticData["quest"].text,
						desc = self.StaticData["quest"].desc,
						type = "toggle",
						set = function(info, value) GoldLoot.db.profile.config["quest"].check = value; end,
						get = function(info) return GoldLoot.db.profile.config["quest"].check end,
					},
					["repair"] = {
						order = 4,
						name = self.StaticData["repair"].text,
						desc = self.StaticData["repair"].desc,
						type = "toggle",
						set = function(info, value) GoldLoot.db.profile.config["repair"].check = value; end,
						get = function(info) return GoldLoot.db.profile.config["repair"].check end,
					},
					["release"] = {
						order = 5,
						name = self.StaticData["release"].text,
						desc = self.StaticData["release"].desc,
						type = "toggle",
						set = function(info, value) GoldLoot.db.profile.config["release"].check = value; end,
						get = function(info) return GoldLoot.db.profile.config["release"].check end,
					},
					["bop"] = {
						order = 6,
						name = self.StaticData["bop"].text,
						desc = self.StaticData["bop"].desc,
						type = "toggle",
						set = function(info, value) GoldLoot.db.profile.config["bop"].check = value; end,
						get = function(info) return GoldLoot.db.profile.config["bop"].check end,
					},
					titleCategory = {
						order = 7,
						type = "header",
						name = "Loot Category Settings",
					}
				}
			}
		}
	}
	
	local i = 8;
	for index, data in ipairs(self.StaticData) do
		self.opts.args.general.args[tostring(index)] = {
			order = i,
			name = self.StaticData[index].text,
			desc = self.StaticData[index].desc,
			type = "toggle",
			set = function(info, value) GoldLoot.db.profile.config[index].check = value; end,
			get = function(info) return GoldLoot.db.profile.config[index].check end,
		};
		i = i + 1;
	end
	
	self.opts.args.general.args["rarityDropDown"] = {
		order = i,
		name = "Minimun autoloot Quality",
		values = self.rarity.name,
		type = "select",
		style = "dropdown",
		set = function(info, value) GoldLoot.db.profile["rarity"] = value; end,
		get = function(info) return GoldLoot.db.profile["rarity"] end,
	};
	
	self.opts.args.profile = AceDBOptions:GetOptionsTable(self.db)
	AceConfig:RegisterOptionsTable("GoldLoot Config", self.opts)
	
	self.optionsFrames = {}
	self.optionsFrames.general = AceConfigDialog:AddToBlizOptions("GoldLoot Config", "GoldLoot", nil, "general")
	self.optionsFrames.profile = AceConfigDialog:AddToBlizOptions("GoldLoot Config", "Profiles", "GoldLoot", "profile")
		
	self:RegisterChatCommand("GoldLoot", "slashHandler")
	self:RegisterChatCommand("gl", "slashHandler")
	
	self:RegisterEvent("MERCHANT_SHOW", "mercShow");
	self:RegisterEvent("PLAYER_DEAD", "autorelease");
	self:RegisterEvent("LOOT_OPENED", "lootOpened");
	self:RegisterEvent("LOOT_CLOSED", "lootClosed");
end

function GoldLoot:OnEnable()
    self:echo("|cff00ff00Enabled.|r",1);
end

function GoldLoot:OnDisable()
    self:echo("|cffff0000Disabled.|r",1);
end

function GoldLoot:echo(txt,mode)
	if( DEFAULT_CHAT_FRAME and not(mode == 2) ) then
		self:Print(txt);
	end
	if( UIErrorsFrame and not(mode == 1) ) then
		self:Print(UIErrorsFrame, txt );
	end
end

-- Get item ID from a link
function GoldLoot:GetLinkId(link)
	local itemID = 0;
	if link then
		_, _, itemID = link:find("|Hitem:(%d+):%d+:%d+:");
	end
	
	return tonumber(itemID or 0);
end

-- Get item ID from a loot slot index
function GoldLoot:GetLootId(slot)
	return self:GetLinkId( GetLootSlotLink(slot) );
end

-- Set Minimun Junk Price
function GoldLoot:SetMinVendorPrice(minPrice)
	self.db.profile.vendorPrice = minPrice;
	minPriceGold = floor(minPrice/10000);
	minPriceSilver = floor((minPrice - minPriceGold*10000)/100);
	minPriceCooper = minPrice - minPriceGold*10000 - minPriceSilver*100;
	if (minPriceGold > 0) then
		self:echo("Minimun Vendor Price: "..format(GOLD_AMOUNT_TEXTURE,minPriceGold,0,0).." "..format(SILVER_AMOUNT_TEXTURE,minPriceSilver,0,0).." "..format(COPPER_AMOUNT_TEXTURE,minPriceCooper,0,0)..".",1);
	elseif (minPriceSilver > 0) then
		self:echo("Minimun Vendor Price: "..format(SILVER_AMOUNT_TEXTURE,minPriceSilver,0,0).." "..format(COPPER_AMOUNT_TEXTURE,minPriceCooper,0,0)..".",1);
	else
		self:echo("Minimun Vendor Price: "..format(COPPER_AMOUNT_TEXTURE,minPriceCooper,0,0)..".",1);
	end
end
	
-- Item Management
function GoldLoot:ItemFunc(arg, func)
	if func == "ilist" then
		table.foreach(self.db.profile.items, function(itemID, LootInfo)
			if (self.db.profile.items[itemID]) then
				self:Print("\124cff"..self.rarity.color[self.db.profile.items[itemID].rarity].."\124Hitem:"..itemID..":0:0:0:0:0:0:0:0\124h["..self.db.profile.items[itemID].name.."]\124h\124r");
			end
		end);
	else
		local runIndex = 0;
		while (true) do
			runIndex = runIndex + 1;
			local _, idEnd, idStr = arg:find("|Hitem:(%d+):%d+:%d+:");
			itemID = tonumber(idStr or false)
			if (itemID) then
				local itemName, itemLink, itemRarity, _, _, itemType, itemSubType = GetItemInfo(itemID);
				if (itemID and func == "add") then
					if not(self.db.profile.items[itemID]) then
						self.db.profile.items[itemID] = {};
						self.db.profile.items[itemID].name = itemName;
						self.db.profile.items[itemID].rarity = itemRarity;
						self.db.profile.items[itemID].loot = true;
						self:Print(itemLink.." added to autoloot list.");
						
						if (self.isLootOpen) then
							GoldLoot:lootOpened(); --Autoloot right after adding a new item.
						end
					else
						self:Print(itemLink.." is already in the autoloot list.");
					end
				elseif (itemID and func == "delete") then
					if self.db.profile.items[itemID] then
						self.db.profile.items[itemID] = nil;
						self:Print(itemLink.." removed from autoloot list.");
					else
						self:Print(itemLink.." is not on the autoloot list");
					end
				elseif (itemID and func == "idata") then
					self:Print(itemLink.."ID:"..itemID.." Type: "..itemType.." - "..itemSubType.." Rarity: "..self.rarity.name[itemRarity]);
				end
				arg = arg:sub(idEnd+1);
			else break end
			if (idEnd >= arg:len() or runIndex > 4) then break end
		end
	end
end

-- Autolooting
function GoldLoot:lootClosed()
	self.isLootOpen = false;
end

function GoldLoot:lootOpened()
	self.isLootOpen = true;
	
	if not(GetCVarBool("autoLootDefault")) then -- and not(UnitAffectingCombat("player")) then
		local lootCount = GetNumLootItems();
		
		if not(lootCount) then
			self:echo(" |cFFFF0000Empty loot|r",2);
			CloseLoot();
			return;
		end
		
		local inInstance, instanceType = IsInInstance();
		local lootmethod = GetLootMethod();
		local numQuests = GetNumQuestLogEntries();
		local questItems = {};
		
		
		-- Get items needed for currently active quests
		if (numQuests > 0 and self.db.profile.config["quest"].check) then
			ExpandQuestHeader(0);
			local QuestSelected = GetQuestLogSelection();
			for Qslot = 1, numQuests ,1 do
				SelectQuestLogEntry(Qslot);
				local numQuestChoices = GetNumQuestLeaderBoards();
				if (numQuestChoices > 0) then
					for QIslot = 1, numQuestChoices ,1 do
						local leaderboardTxt, QLitemType, isDone = GetQuestLogLeaderBoard(QIslot);
						if ( QLitemType == "item" and not isDone) then
							local _, _, itemName = leaderboardTxt:find("%d+/%d+ (.*)$");
							if itemName then
								questItems[itemName] = true;
							end
						end
					end
				end
			end
			SelectQuestLogEntry(QuestSelected);
		end
		
		
		
		for slotnum = 1, lootCount do
			local canloot = false;
			local itemID = self:GetLootId( slotnum );
			local itemName, _, itemrarity, itemLevel, _, itemType, itemSubType, itemStackCount, _, _, itemVendorPrice = GetItemInfo(itemID);
			
			local _, _, _, _, locked = GetLootSlotInfo( slotnum );
			
			
			if GetLootSlotType(slotnum) > 1 then
				canloot = true;
			elseif (itemID ~= 0) then
				if itemrarity >= self.db.profile.rarity
				or (self.db.profile.config["junk"].check and itemrarity == 0 and itemVendorPrice*ceil(itemStackCount/2) > self.db.profile.vendorPrice)
				or (self.db.profile.config["quest"].check and questItems[itemName]) or (self.db.profile.config[7].check and (itemName:lower():match("lockbox") or itemName:lower():match("junkbox")))then
					canloot = true;
				else
					if (itemType == "Trade Goods") then
						for index, data in ipairs( self.StaticData ) do
							if (self.db.profile.config[index].check and data.loot) then
								if (itemSubType == data.loot) then
									canloot = true;
								end
							end
						end
					end
					
					if (self.db.profile.items[itemID]) then
						if (self.db.profile.items[itemID].loot) then
							canloot = true;
						end
					end
				end
				
				--if canloot and (GetNumPartyMembers()>0 or GetNumRaidMembers()>0) and not(lootmethod == "freeforall" or itemrarity < GetLootThreshold() or IsFishingLoot()) or (inInstance and instanceType == "pvp") then
					--canloot = false;
				--end
			end
			
			if(canloot and not(locked))then 
				LootSlot(slotnum);
				if (self.db.profile.config["bop"].check) then
					ConfirmLootSlot(slotnum);
				end
				StaticPopup_Hide("LOOT_BIND"); --hide loot confirm popup
			end
		end
	end
end

-- Repair/Sell Junk
function GoldLoot:mercShow()
	-- junk selling
	if (self.db.profile.config["junk"].check) then
		--local soldItems = {};
		local moneyEarnedRaw = 0;
		for Container = 0, 5 ,1 do
			if (GetContainerNumSlots(Container)~=nil)then
				local contSlots=GetContainerNumSlots(Container);
				for Slot = 1, contSlots+1 ,1 do
					local contItemlink=GetContainerItemLink(Container,Slot);
					if (contItemlink~=nil)then                        
						local contItemName, _, contItemQuality, _, _, contItemType, contItemSubtype, _, _, _, contItemSellPrice=GetItemInfo(contItemlink);
						local contItemID = self:GetLinkId(contItemlink);
						local _, contItemCount, contItemlocked, _, _ = GetContainerItemInfo(Container,Slot);
						if(contItemQuality == 0 and not(contItemlocked) and self.db.profile.items[contItemID] == nil)then
							UseContainerItem(Container,Slot);
							local itemPriceRaw = contItemSellPrice*contItemCount;
							moneyEarnedRaw = moneyEarnedRaw + itemPriceRaw;
						end
					end
				end
			end
		end
		if (moneyEarnedRaw ~= 0) then
			local moneyEarnedGold = floor(moneyEarnedRaw/10000);
			local moneyEarnedSilver = floor((moneyEarnedRaw - moneyEarnedGold*10000)/100);
			local moneyEarnedCooper = moneyEarnedRaw - moneyEarnedGold*10000 - moneyEarnedSilver*100;
			
			local moneyText = "";
			if (moneyEarnedGold > 0) then
				moneyText = moneyText..format(GOLD_AMOUNT_TEXTURE,moneyEarnedGold,0,0);
			end
			if (moneyEarnedSilver > 0) then
				moneyText = moneyText..format(SILVER_AMOUNT_TEXTURE,moneyEarnedSilver,0,0);
			end
			if (moneyEarnedCooper > 0) then
				moneyText = moneyText..format(COPPER_AMOUNT_TEXTURE,moneyEarnedCooper,0,0);
			end
			
			self:echo("Collected "..moneyText);
		end
	end
	-- auto repair
	if (CanMerchantRepair() and self.db.profile.config["repair"].check) then
		local repairAllCost, canrepair = GetRepairAllCost();
		if (canrepair and (GetMoney() > repairAllCost)) then
			RepairAllItems(false);
			moneyUsedGold = floor(repairAllCost/10000);
			moneyUsedSilver = floor((repairAllCost - moneyUsedGold*10000)/100);
			moneyUsedCooper = repairAllCost - moneyUsedGold*10000 - moneyUsedSilver*100;
			
			local repairText = "repair cost: ";			
			if (moneyUsedGold > 0) then
				repairText = repairText..format(GOLD_AMOUNT_TEXTURE,moneyUsedGold,0,0);
			end
			
			if (moneyUsedSilver > 0) then
				repairText = repairText..format(SILVER_AMOUNT_TEXTURE,moneyUsedSilver,0,0);
			end
			
			if (moneyUsedCooper > 0) then
				repairText = repairText..format(COPPER_AMOUNT_TEXTURE,moneyUsedCooper,0,0);
			end
			
			self:echo(repairText);
		elseif (GetMoney() < repairAllCost ) then
			self:echo("Not enough money to repair.",1);
		end
	end
end

-- AutoRelease
function GoldLoot:autorelease()
	if self.db.profile.config["release"].check then
		local inInstance, instanceType = IsInInstance();
		local canRess = HasSoulstone();
		if (((inInstance and instanceType == "pvp") or self.PVPAreas[GetRealZoneText():lower()]) and not(canRess)) then
			RepopMe();
		end
	end
end

function GoldLoot:slashHandler(arg)
	local arg1 = arg:lower()
	if arg1 == "config" then
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrames.general);
	elseif arg1:sub(1, 3) == "add" then
		GoldLoot:ItemFunc(arg:sub(4,arg:len()),"add");
	elseif arg1:sub(1, 6) == "delete" or arg1:sub(1, 3) == "del" then
		GoldLoot:ItemFunc(arg:sub(7,arg:len()),"delete");
	elseif arg1:sub(1, 5) == "idata" then
		GoldLoot:ItemFunc(arg:sub(6,arg:len()),"idata");
	elseif arg1:sub(1, 5) == "ilist" then
		GoldLoot:ItemFunc(arg:sub(6,arg:len()),"ilist");
	elseif arg1:sub(1, 8) == "minprice" then
		GoldLoot:SetMinVendorPrice(tonumber(arg:sub(9,arg:len()) or 0));
	else
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrames.general);
		GoldLoot:echo("\"/gl reset/resetforce\" to reset GoldLoot's data to default.",1);
		GoldLoot:echo("\"/gl config\" to configure GoldLoot.",1);
		GoldLoot:echo("\"/gl add [ItemLink][ItemLink]...\" to add the specified item(s) to the autoloot list.",1);
		GoldLoot:echo("\"/gl delete [ItemLink][ItemLink]...\" to remove the specified item(s) from the autoloot list.",1);
		GoldLoot:echo("\"/gl nimprice (number)\" to set the minimun price per stack of junk to autoloot (in coppers).",1);
	end
end
